;--------------------------------------------------------------+-----------+
;       Scan_GRPH_FK  [FE1]`[FE7]L[Ń[hIEL   | 2024/11/13|
; L[Ԃ݂    keycode   e[h̊OlɑΉ |           |
;--------------------------------------------------------------+-----------+
Scan_GRPH_FK   PROC   near
                mov     cx,7777
        @@:     mov     ah,2
                int 18h
                test    al,00001000b    ; 1=SHIFT, 8=GRPH
                jnz     EnterValue
                test    al,00010000b    ; 16=CTRL
                jnz     CancelProgram
               loop     @b
                jmp     ScanFKEY_abort
EnterValue:     
                call    FnKeyMenu
                call    Poop            ; ````
                xor     ax,ax   ; wait while keybord input 
                int 18h         ; return: AL=key DATA, AH=key CODE
                dec     ROW
                mov     dx,offset Clear80
                call    _puts
                dec     ROW
                mov     dx,offset Clear80
                call    _puts
                dec     ROW
                xchg    al,ah   ; with key CODE
                or      al,al   ; key code 00h=[ESC] ,AL=0
                jz      CancelProgram

                cmp     al,62h  ; key Code 62h=[F.1] 
                jb      EnterValue
                cmp     al,67h  ; key Code 67h=[F.6]
                ja      EnterValue
                sub     al,61h          ; -61hOlƂȂ
                and     al,00000111b    ; Mask for safety
                mov     ModeID,al       ; [hlm肷
                
                push    ax
                mov     al,0Dh          ; XCb`\ɂ
                out 68h,al
                pop     ax
                call    Poop            ; ````
                call    Peee            ; ````

                mov     COLUMN,0        ; JOɂ
                mov     bx,3FF6h        ; XCb`U
                mov     ah,es:[bx]      ; XCb`Uǂݍ
                and     ah,11111000b    ; ̃rbgۑ̃}XN
                or      al,ah
                mov     es:[bx],al      ; XCb`Uɏ
                mov     al,0Ch          ; XCb`֎~ɂ
                out 68h,al
ScanFKEY_abort:
                mov     al,ModeID
                clc
                ret
Div0Only:
CancelProgram:  mov     al,7
                stc
                ret
Clear80         DB     0E1h,"                                                                                ",0
Scan_GRPH_FK   ENDP

FnKeyMenu       PROC   near
                mov     dx,offset FnKey1  
                call    _puts
                mov     dx,offset ModeEx1 
                call    _puts
                mov     dx,offset FnKey2  
                call    _puts
                mov     dx,offset ModeEx2 
                call    _puts
                mov     dx,offset FnKey3  
                call    _puts
                mov     dx,offset ModeEx3 
                call    _puts
                mov     dx,offset FnKey4  
                call    _puts
                mov     dx,offset ModeEx4 
                call    _puts
                mov     dx,offset FnKey6  
                call    _puts
                mov     dx,offset ModeEx6 
                call    _puts
                ret
FnKey1          DB     0E5h,"P",0
ModeEx1         DB     0A1h,"IDEgCF/SSD,  ",0
FnKey2          DB     0E5h,"Q",0
ModeEx2         DB     081h,"IDEgHD,  ",0
FnKey3          DB     0E5h,"R",0
ModeEx3         DB     0A1h,"SCSI݊CF/SSD,  ",0
FnKey4          DB     0E5h,"S",0
ModeEx4         DB     081h,"SCSI݊HD,  ",0
FnKey6          DB     0E5h,"U",0
ModeEx6         DB     0E1h,"div0ROM",0
FnKeyMenu       ENDP

;----------------------------------------------------
;       DisplayParamMode6
;----------------------------------------------------
DisplayParamMode6       PROC   near
                mov     dx,offset msg_set 
                mov     es,SegTVRAM
                mov     al,byte ptr es:[3FF6h]  ; XCb`U̎w
                and     al,00000111b            ; }XN
                or      al,al   ; XCb`O
                jnz     @f      
                mov     dx,offset msg_default ; ̂ƂftHg
        @@:     call    _puts
                mov     dx,offset msg_param_is
                call    _puts
                mov     ah,0
                mov     al,ModeID
                call    digitx1

                mov     al,ModeID
                mov     ah,0

                push    ax
                mov     ah,0
                inc     ax
                mov     al,1
                jae     safevalue
                mov     al,6
                jbe     safevalue
                mov     al,06h
                out 37h,al
                mov     al,0
safevalue:
                pop     ax

                shl     ax,1
                mov     bx,offset ParaMsgBase
                add     bx,ax
                mov     dx,ds:[bx]
                call    _puts           ; [hl̕񂩂\
                RET
mode0   DB      041h," `",13,10,0
mode1   DB      0E1h," IDEg SSD,CFœK[h(4351MBȉ H:S _8:17,16:63 )",13,10,0
mode2   DB      0E1h," IDEg HD݊[h(4351MBȉ H:S=8:17)",13,10,0
mode3   DB      0E1h," SCSI݊[hiSSD,CFœKj",13,10,0
mode4   DB      0E1h," SCSI݊[hiHDDœKj",13,10,0
mode5   DB      0E1h," SCSI݊[h(32GBȏIFC-USP݊)",13,10,0
mode6   DB      0E1h," DIV0ROM ݂̂Kp  ",0

ParaMsgBase     label   word
                DW      offset mode0
                DW      offset mode1
                DW      offset mode2
                DW      offset mode3
                DW      offset mode4
                DW      offset mode5
                DW      offset mode6
                DW      offset mode0
DisplayParamMode6       ENDP



